java基础——异常分类、处理机制

异常Exception

  • 实际工作中,遇到的情况不可能是非常完美的。比如:你写某个模块,用户不一定符合你的要求,你读取数据库是,数据可能是空的。。。
  • 软件程序在运行中,,非常可能遇到上述i情况, 我们成为异常。
  • 异常:指程序在运行过程中出现了不期而至的各种情况。
  • 异常发生在程序运行期间,它影响了正常的程序执行流程。

异常的简单分类

  1. 检查行异常:最具有代表性的检查行异常时用户错误或者问题出现的异常,这个时程序员无法预见的。
  2. 运行时异常:运行时异常时可能被程序员避免的异常,一检查行相反,运行时异常可以在编译时被忽略
  3. 错误:错误不是异常,而是脱离程序员控制的问题。错误在代码中通常被忽略。

异常的体系结构

image

  • java 把异常当作对象来处理,并定义了一个基类java.lang.Throwable作为所有异常的超类
  • 在java 中API中已经定义了许多的异常结构,这些异常结构,分为两大类,一类时错误Error和异常Exception

Error

  • Error类对象由java虚拟机生成并抛出,大多数错误与代码编写者所执行的操作无关
  • java 虚拟机运行错误(Virtual MechinceError),当JVM不再有继续执行操作所需要的内存资源时,将出现OutOfMemoryError。这些异常发生时,java虚拟机(JVM)一般会选择线程终止
  • 还有发生在虚拟机试图执行应用时,如类定义错误(NoClassDefFoundError)、链接错误(LinkageError),这些错误不可查,因为他们在应用程序的控制和处理能力之外,而且绝大多数时程序运行时不允许出现的状况。

Exception

异常处理机制

  • 抛出异常

  • 捕获异常

  • 异常的五个关键字

    • try、catch、finally、throw、throws
    public static void main(String[] args) {

        int a=1;
        int b=0;

        try {//监控区域
            System.out.println(a/b);
        }catch(ArithmeticException e){//想要捕获的异常类型,
            System.out.println("出现错误,被除数不能为0");
        }finally {
            System.out.println("finally");
        }
        //try catch必须要,finally可以不要,但是它可以处理一些善后工作,比如关闭IO流、资源······
    }
    public static void main(String[] args) {

        int a = 1;
        int b = 0;

        //如果要捕获多个异常,要从小到大的捕获

        try {//监控区域
            System.out.println(a / b);
            ;
        } catch (Error e) {//想要捕获的异常类型,
            System.out.println("Error");
        } catch (Exception e) {
            System.out.println("Exception");
        } catch (Throwable e) {
            System.out.println("throwable");
        } finally {
            System.out.println("finally");
        }
        //try catch必须要,finally可以不要,但是它可以处理一些善后工作,比如关闭IO流、资源······
    }
    public static void main(String[] args) {
        int a = 1;
        int b = 0;

        //Ctrl+Alt+T;快速生成抛出异常
        try {
            System.out.println(a / b);
        } catch (Exception e) {
            System.exit(1);//手动的结束程序
            e.printStackTrace();//打印错误的栈信息
        } finally {
        }
    }
    public static void main(String[] args) {
        try {
            Test3 test3 = new Test3();
            test3.test(1,0);
        } catch (ArithmeticException e) {
            e.printStackTrace();
        } finally {
        }
    }
    //如果在方法中处理不了这个异常,那么在方法上抛出异常
    public void test(int a,int b) throws  ArithmeticException{
     //主动的抛出异常,一般在方法中使用, 一旦在
        if(b==0){
            throw new ArithmeticException();
        }
        System.out.println(a/b);
    }

自定义异常

  • 用户自定义的异常类,只需继承Exception类即可
  • 在程序中使用自定义异常类,大体可分为一下几个步骤:
    1. 创建自定义异常类
    2. 在方法中通过throw关键字抛出异常对象
    3. 如果在当前爬出异常的方法中处理对象,可以是使用try-catch语句捕获并处理;否则在方法的声明出通过throw关键字知名要抛出给方法调用者的异常,继续下一步操作。
    4. 在出现异常方法的调用者中,捕获并处理异常。
public class MyException extends Exception{
    //当数字>10时抛出异常
    private int detail;
    public MyException(int a) {
        this.detail = a;
    }
    //to string打印信息
    @Override
    public String toString() {
        return "MyException{" +
                "detail=" + detail +
                '}';
    }
}
//=========================================
public class Test {
    static void test(int a) throws MyException {

        System.out.println("传递的参数为"+a);
        if(a>10){
            throw new MyException(a);
        }
        System.out.println("OK");
    }
    public static void main(String[] args) {
        try {
            test(11);
        } catch (MyException e) {
            //增加一些异常处理的代码块
            System.out.println("MyException=>"+e);;
        }
    }
}

实际经验的总结:

1. 处理运行的异常时,逻辑去合理规避同时辅助try-catch处理
2. 在多重catch块后面,可以加一个catch(Exception)来处理可能会被遗漏的异常
3. 对于不确定代码,也可以加上try-catch,处理潜在的异常
4. 尽量去处理异常,切记只是简单地条用printStackTrace()去打印输出
5. 具体如何处理异常,要更具不同的业务需求和异常类型去决定
6. 尽量添加finally语句去释放占用的资源
posted @ 2021-05-28 13:35  放慢_脚步  阅读(71)  评论(0编辑  收藏  举报